

module mtest2
using StaticArrays
using MeshCore: Locations, nlocations, coordinates, nspacedims, coordinatetype
using MeshCore: LocAccess, locations
import MeshFinder: vselect, initbox, updatebox!
using Test
function test()
    xyz = [0.0 0.0; 633.3333333333334 0.0; 1266.6666666666667 0.0; 1900.0 0.0; 0.0 400.0; 633.3333333333334 400.0; 1266.6666666666667 400.0; 1900.0 400.0; 0.0 800.0; 633.3333333333334 800.0; 1266.6666666666667 800.0; 1900.0 800.0]
    v =  Locations(xyz)
    @test nlocations(v) == 12
    x = coordinates(v, SVector{2}([2, 4]))
    @test x[1] == SVector{2}([633.3333333333334 0.0])
    @test nspacedims(v) == 2
    @test coordinatetype(v) == Float64
    la = LocAccess(v)
    @test locations(la) == v

    box = [0.0 0.0 0.0 0.0]
    inflate = 0.01
    outputlist = vselect(la, nlocations(la), box = box, inflate = inflate)
    @test isapprox(outputlist, [1])

    box = initbox(xyz)
    outputlist = vselect(la, nlocations(la), box = box, inflate = inflate)
    @test isapprox(outputlist, collect(1:size(xyz, 1)))

    box = initbox(xyz[2, :])
    updatebox!(box, xyz[6, :])
    outputlist = vselect(la, nlocations(la), box = box, inflate = inflate)
    @test isapprox(outputlist, [2, 6])

    box = initbox(xyz[5, :])
    updatebox!(box, xyz[6, :])
    outputlist = vselect(la, nlocations(la), box = box, inflate = inflate)
    @test isapprox(outputlist, [5, 6])
    true
end
end
using .mtest2
mtest2.test()

# include("samplet4.jl")

# module mt4topo1
# using StaticArrays
# using MeshCore: P1, T4, ShapeColl,  manifdim, nvertices, nridges, nshapes
# using MeshCore: bbyridges, skeleton, bbyfacets, nshifts, _sense, retrieve
# using MeshCore: IncRel, Locations, transpose, nrelations, nentities, nlocations
# using ..samplet4: samplet4mesh
# using Test
# function test()
#     xyz, cc = samplet4mesh()
#     # Construct the initial incidence relation
#     locs = Locations(xyz)
#     vrts = ShapeColl(P1, nlocations(locs))
#     tets = ShapeColl(T4, size(cc, 1))
#     ir30 = IncRel(tets, vrts, cc)
#     # Test the incidence relations 3 -> 0 & 0 -> 3
#     ir03 = transpose(ir30)
#     allmatch = true
#     for j in 1:nrelations(ir03)
#         for k in 1:nentities(ir03, j)
#             f = retrieve(ir03, j, k)
#             allmatch = allmatch && (j in retrieve(ir30, f))
#         end # k
#     end # j
#     @test allmatch

#     # Test the incidence relations 2 -> 0 & 0 -> 2
#     ir20 = skeleton(ir30)
#     ir02 = transpose(ir20)
#     allmatch = true
#     for j in 1:nrelations(ir02)
#         for k in 1:nentities(ir02, j)
#             f = retrieve(ir02, j, k)
#             allmatch = allmatch && (j in retrieve(ir20, f))
#         end # k
#     end # j
#     @test allmatch

#     # Test the incidence relations 1 -> 0 & 0 -> 1
#     ir10 = skeleton(ir20)
#     ir01 = transpose(ir10)
#     allmatch = true
#     for j in 1:nrelations(ir01)
#         for k in 1:nentities(ir01, j)
#             f = retrieve(ir01, j, k)
#             allmatch = allmatch && (j in retrieve(ir10, f))
#         end # k
#     end # j
#     @test allmatch

#     # Test the incidence relations 3 -> 2 & 2 -> 3
#     ir20 = skeleton(ir30)
#     ir32 = bbyfacets(ir30, ir20)
#     # Check that the tetrahedra connectivity refers to all three vertices of the faces
#     allmatch = true
#     @test nrelations(ir30) == nrelations(ir32)
#     for j in 1:nrelations(ir32)
#         for k in 1:nentities(ir32, j)
#             f = retrieve(ir32, j, k)
#             for m in 1:3
#                 allmatch = allmatch && (retrieve(ir20, abs(f), m) in retrieve(ir30, j))
#             end # m
#         end # k
#     end # j
#     @test allmatch
#     # Check that the orientations of the faces is correct
#     allmatch = true
#     @test nrelations(ir30) == nrelations(ir32)
#     for j in 1:nrelations(ir32)
#         for k in 1:nentities(ir32, j)
#             for f in retrieve(ir32, j)
#                 orientation = sign(f)
#                 f = abs(f)
#                 fc = retrieve(ir20, f)
#                 matchone = false
#                 for m in 1:4
#                     oc = retrieve(ir30, j)[ir30.left.shapedesc.facets[m, :]]
#                     if length(intersect(fc, oc)) == 3
#                         s = _sense(fc, oc, nshifts(ir20.left.shapedesc))
#                         matchone = (s == orientation)
#                     end
#                     if matchone
#                         break
#                     end
#                 end # m
#                 allmatch = allmatch && matchone
#             end
#         end # k
#     end # j
#     @test allmatch
#     # Check the transpose incidence relation
#     ir23 = transpose(ir32)
#     allmatch = true
#     for j in 1:nrelations(ir23)
#         for k in 1:nentities(ir23, j)
#             e = retrieve(ir23, j, k)
#             allmatch = allmatch && (j in abs.(retrieve(ir32, e)))
#         end # k
#     end # j
#     @test allmatch
#     true
# end
# end
# using .mt4topo1
# mt4topo1.test()
